
#include <iostream>
#include <vector>
#include "histogram.h"
using namespace std;

bool find_minmax(const vector<double> &numbers, double &min, double &max){
    if (numbers.empty())return false;
    else{
    max = numbers[0];
    min = numbers[1];
    for (double x: numbers)
    {
        if (x < min)
        {
            min = x;
        }
        else if (x > max)
        {
            max = x;
        }
    }
    return true ;
}
}
vector<size_t> make_histogram (vector<double> numbers, size_t bin_count)
{

    double minn;
    double maxx;
    find_minmax (numbers, minn, maxx);
    double bin_size = (maxx - minn) / bin_count;
    vector<size_t> bins(bin_count);
    for (size_t i = 0; i < numbers.size(); i++)
    {
        bool found = false;
        for (size_t j = 0; (j < bin_count - 1) && !found; j++)
        {
            auto lo = minn + j * bin_size;
            auto hi = minn + (j + 1) * bin_size;
            if ((lo <= numbers[i]) && (numbers[i] < hi))
            {
                bins[j]++;
                found = true;
            }
        }
        if (!found)
        {
            bins[bin_count - 1]++;
        }
    }
    return bins;
}

vector<double> make_borders(const vector<double>& numbers, size_t bin_count){
    double min, max;
    find_minmax(numbers, min, max);
    double diff = (max - min) / bin_count;
    std::vector <double> borders(bin_count - 1);
    for (size_t i = 0; i <= bin_count - 2; i++){
        borders[i] = min + (i + 1) * diff;
    }
    return borders;
}

